*      Integration of equation of motion
*      Parallel version 
*
*=============== SULTAN ================================================
*
      SUBROUTINE SULTAN
*
*  Constrained MD
*
      include "prcm.h"  
*
      LOGICAL DONE,LRDF
      real*8 VIRR(3)
      CHARACTER*1 NONE,SOME,WHICH
      DATA NONE,SOME /' ','.'/,LRDF/.false./
*
*>----------------------------
	CALL GETCOM     ! supl.f
	call CHCNB(LRDF)        ! mdstep.f  
	call GETEMP(.true.)
	LRDF=.true.
      NSTEP=0
 1    NSTEP=NSTEP+1
      MSTEP=NSTTOT+NSTEP
*>----------------------------
*
        CALL ZEROFS(1)
	  call ZEROAV
*       
      CALL ZEROFS(2)  ! supl.f         
      CALL FURIR      ! l-forces.f
      CALL FORCES     ! l-forces.f   
      CALL ETERMS     ! l-forces.f
	CALL CM_ADDLF    ! mpi.f
*      if(LNPT)call ELRCLJ     ! l-forces.f 
	if(LRR)call PULLBACK
*     
	VIR1=0.
	call LOCALF         ! l-forces.f
      CALL GETBND  
      CALL GETANG         ! i-forces.f
      CALL GETTRS         ! i-forces.f  
	call CM_ADDF(.true.)
      timeg0	= cputime(0.d0)
*  Forces summation 
      DO I           = NAB(TASKID),NAE(TASKID)
        FX(I)          = HX(I)+GX(I)
        FY(I)          = HY(I)+GY(I)
        FZ(I)          = HZ(I)+GZ(I)
      END DO! OF I  
      timeg	= timeg+cputime(timeg0)
*	call GATFOR
      timeg0	= cputime(0.d0)
*
      CALL SCLFRC(DONE,3)
*
      DO I         = NAB(TASKID),NAE(TASKID)
*Temporary array: Constrained velocities at n-1/2
        HX(I)        = VX(I)
        HY(I)        = VY(I)
        HZ(I)        = VZ(I)
Constrained positions at n  (now)
        OX(I)        = SX(I)
        OY(I)        = SY(I)
        OZ(I)        = SZ(I)
*Unconstrained velocities at step n+1/2
        VX(I)        = VX(I)+TSTEP*FX(I)
        VY(I)        = VY(I)+TSTEP*FY(I)
        VZ(I)        = VZ(I)+TSTEP*FZ(I)
*Unconstrained  postions  at step n+1 
        SX(I)        = SX(I)+TSTEP*VX(I)*MASSDI(I)
        SY(I)        = SY(I)+TSTEP*VY(I)*MASSDI(I)
        SZ(I)        = SZ(I)+TSTEP*VZ(I)*MASSDI(I)
*fx is used as a temporary array for unconstrained positions (now OX...)
        FX(I)       = SX(I)
        FY(I)       = SY(I)
        FZ(I)       = SZ(I)
	end do
*
*  Constrain dynamics                           
	IMB=NNUM(NAB(TASKID))
	IME=NNUM(NAE(TASKID))
	do IMOL=IMB,IME  
	  CALL SHEJK(IMOL)
	end do
      call SUMMA(VIRA,VIRR,3,MAST)
      VIR	= VIR+VIRR(1)+VIRR(2)+VIRR(3)
      VIRA(1)=VIRR(1)
      VIRA(2)=VIRR(2)
      VIRA(3)=VIRR(3)
*  Realization of specified ensemble
      CALL SCALING(1)
      CALL GETCOM     ! supl.f
*  Collecting averages
      timeg	= timeg+cputime(timeg0)
	call SINHR(1)
	if(mod(MSTEP,ICHNB).eq.0)then
          call CHCNB(LRDF)
        end if
        call SINHV(1)
      timeg0	= cputime(0.d0)
*
	CALL GETKIN     ! supl.f
*	CALL GETROT     ! supl.f      seems don't work
      if(LCF)CALL DIPOLE
        if(NHIST+1.ge.IHIST)CALL GETTCF
	  if(mod(MSTEP,IAVER).eq.0)CALL GETAVR(1)
	if(mod(MSTEP,NTREK).eq.0)CALL TRACE
*     
      VIRL=VIRL+VIRLS
	PEST=PEST+PELS
	WIRS=WIRS+WIRSS
      TRYCKE	= PEST*UNITP/(3.*VOL)    ! electrostatic contr.
      TRYCKL	= VIRL*UNITP/(3.*VOL)    ! LJ
      TRYCKB	= VIRB*UNITP/(3.*VOL)    ! bond (flexible)
      TRYCKT	= VIRT*UNITP/(3.*VOL)    ! imp.
      TRYCKN	= VIRN*UNITP/(3.*VOL)    ! interaction inside a molecule
      TRYCKF	= WIRF*UNITP/(3.*VOL)    ! self-int. correction (rigid)
      TRYCKA	= (VIRA(1)+VIRA(2)+VIRA(3))*UNITP/(3.*VOL) ! shejk-correction 
	TRYCKS	= WIRS*UNITP/(3.*VOL)    ! orientational correction
	TRYCKD	= VIRD*UNITP/(3.*VOL)    ! long-range correction
      PENL=PE*0.001*ENERF/FNOP
      PEL=PEST*0.001*ENERF/FNOP
      PENS=PINT*0.001*ENERF/FNOP
      PEKI=TKE*0.001*ENERF
      ETOT=PENL+PENS+PEKI
      POTEN	= PENL+PENS
	PHD=POTLJ(MOLINT)*1.d-3*ENERF/NHDM
	DENS	= TOTMAS*1.d-3/(VOL*UNITL**3)
*
               WHICH = NONE
      IF(DONE) WHICH = SOME 
	if(TASKID.eq.MAST)then
        if(IPRINT.ge.5.and.mod(MSTEP,IAVER).eq.0)
     +  WRITE(6,991) MSTEP,POTEN,PENS,PEL,ETOT,TEMP,TRYCKM,DENS
        if(IPRINT.ge.6)write(*,'(2f9.6,6f10.2)')
     +   SC,SCL,TRYCK,PHD,TTR,TROT,TINT,TEMPV
 	  if(IPRINT.ge.7.and.mod(MSTEP,IAVER).eq.0)
     +  WRITE(6,'(8f10.3)')TRYCKL,TRYCKE,TRYCKB,TRYCKA,TRYCKN,
     +  TRYCKF,TRYCKS,TRYCKD
  991   FORMAT(I7,4(1X,F9.3),2(1X,f9.2),f9.4)
**
        IF(mod(MSTEP,NAVER).eq.0)call GETAVR(2)
*** Put you own subroutine for evaluation of whatever you want here:
***     call USER
***
	end if
        if(LDMP.and.mod(NSTTOT+NSTEP,NDUMP).eq.0)call RESTRT(2)
        timeg	= timeg+cputime(timeg0)
*
*<---------------------
      if(NSTEP.lt.NSTEPS)go to 1
*<---------------------
*
      RETURN
      END
*
*=============== DOUBLE ================================================
*
      SUBROUTINE DOUBLE
*
      include "prcm.h"
*
      LOGICAL DONE,LRDF  
	real*8 TRLL(3)
      CHARACTER*1 NONE,SOME,WHICH
      DATA NONE,SOME /' ','.'/
	LRDF=.false.
*
*>----------------------------
*    Restore forces, COM and list of neigbours
*
      CALL ZEROFS(1)
	CALL GETCOM     ! supl.f 
	call CHCNB(LRDF)      ! mdstep.f 
	LRDF=.true.  
**       
	call LOCALF         ! l-forces.f
      CALL GETBND         ! i-forces.f
      CALL GETANG         ! i-forces.f
      CALL GETTRS         ! i-forces.f 
*	I1=NAE(0)
*	I2=NAB(1) 
      call CM_ADDF(.false.)        ! mpl.f 
*                                                  
      CALL ZEROFS(2)  ! supl.f
      CALL FURIR      ! l-forces.f
      CALL FORCES     ! l-forces.f
      CALL ETERMS     ! l-forces.f
	CALL CM_ADDLF    ! mpl.f                     
*
      timeg0	= cputime(0.d0)
      if(LNPT)then
*	  call ELRCLJ     ! l-forces.f
	  if(LSEP)then                 
	    TRLL(1)=(VIRX+VIRD/3.)*UNITP/(3.*VOL)
	    TRLL(2)=(VIRY+VIRD/3.)*UNITP/(3.*VOL)
	    TRLL(3)=(VIRZ+VIRD/3.)*UNITP/(3.*VOL) 
	    call BCAST(TRLL,3,MAST)
	  else
	    TRL=(VIR+PEST+VIRD)*UNITP/(3.*VOL)
	    call BCAST(TRL,1,MAST)
	  end if
	end if    
	if(IPRINT.ge.7)then
	  PELL=PEST+PELS
        PENL=PE*PERMOL
        PEL=PELL*PERMOL
        PENS=PINT*PERMOL
        PEKI=TKE*PERMOL
        ETOT=PENL+PENS+PEKI
        POTEN	= PENL+PENS
       WRITE(6,'(4(a6,f12.5))')
     +' Eex= ',PENL,' Ein= ',PENS,' Eel= ',PEL,' Etot=',ETOT 
	end if
*
*   Begin MD
*
      NSTEP=0
 1    NSTEP=NSTEP+1
	MSTEP=NSTTOT+NSTEP
*>----------------------------
                         
*  velocity correction due to slow forces
        DO I           =  NAB(TASKID),NAE(TASKID)
	    ITYP	= ITYPE(I)
	    if(LMOVE(ITYP))then 
            VX(I)          =   VX(I)+TSTEP*GX(I)*0.5D0
            VY(I)          =   VY(I)+TSTEP*GY(I)*0.5D0
            VZ(I)          =   VZ(I)+TSTEP*GZ(I)*0.5D0
	    end if
        END DO! OF I
        if(LNPT)then
	    if(LSEP)then                 
	      SCLX=SCLX+0.5d0*(TRLL(1)-TRPRES)*VOL*DQP*TSTEP
	      SCLY=SCLY+0.5d0*(TRLL(2)-TRPRES)*VOL*DQP*TSTEP
	      SCLZ=SCLZ+0.5d0*(TRLL(3)-TRPRES)*VOL*DQP*TSTEP
	if(IPRINT.ge.7)write(*,'(i7,3f12.7)')
     +NSTEP,SCLX,SCLY,SCLZ
	    else
	      SCL=SCL+0.5d0*(TRL-TRPRES)*VOL*DQP*TSTEP 
	    end if
	  end if    
*
*- - - - - - - FAST MOTION - - - - - - - -
*     
	call ZEROAV
      DO NSTEB       =  1,NFREQ
        DO I           =  NAB(TASKID),NAE(TASKID)
	      FX(I) = VX(I)
            FY(I) = VY(I)
            FZ(I) = VZ(I)
            OX(I) = SX(I)
            OY(I) = SY(I)
            OZ(I) = SZ(I)
	      ITYP	= ITYPE(I)
	      if(LMOVE(ITYP))then 
              VX(I) =   VX(I)+TSTEB*HX(I)*0.5D0         ! V(t+1/2)
              VY(I) =   VY(I)+TSTEB*HY(I)*0.5D0
              VZ(I) =   VZ(I)+TSTEB*HZ(I)*0.5D0
              SX(I) =   VX(I)*TSTEB*MASSDI(I)+SX(I)     ! X(t+1)
              SY(I) =   VY(I)*TSTEB*MASSDI(I)+SY(I)
              SZ(I) =   VZ(I)*TSTEB*MASSDI(I)+SZ(I)
	      end if
        END DO! OF I
*  Realization of the specified ensemble
        CALL SCALING(2)       ! mdstep.f    
        timeg	= timeg+cputime(timeg0)     
	  call SINHR(2)  
	  CALL GETCOM         ! supl.f
        CALL ZEROFS(1)     ! supl.f
	  if(NSTEB.eq.NFREQ/2+1)then
	    if(mod(MSTEP,ICHNB).eq.0)call CHCNB(LRDF)     
*   Calculation of slow forces
          CALL ZEROFS(2)      ! supl.f
          CALL FURIR          ! l-forces.f
          CALL FORCES         ! l-forces.f
          CALL ETERMS         ! l-forces.f
	    CALL CM_ADDLF    ! mpl.f
*          if(LNPT)call ELRCLJ         ! l-forces.f
          if(NUMTASK.eq.1)CALL SCLFRC(DONE,2)   ! supl.f              
	    if(LRR)call PULLBACK
        end if
*   Claculation of fast forces 
	  VIR1=0.
	  call LOCALF            ! l-forces.f
        CALL GETBND            ! i-forces.f           F(t+1)  
        CALL GETANG            ! i-forces.f
        CALL GETTRS            ! i-forces.f   
	  if(NSTEB.eq.NFREQ)then
 	    call CM_ADDF(.true.)
	  else
	    call CM_ADDF(.false.)
	  end if                                  
*
        CALL SCLFRC(DONE,1)    ! supl.f
*       
      timeg0	= cputime(0.d0)
        DO I           =  NAB(TASKID),NAE(TASKID)
	    ITYP	= ITYPE(I)
	    if(LMOVE(ITYP))then 
            VX(I)          =  VX(I)+TSTEB*HX(I)*0.5D0     !  V(t+1)
            VY(I)          =  VY(I)+TSTEB*HY(I)*0.5D0
            VZ(I)          =  VZ(I)+TSTEB*HZ(I)*0.5D0
          end if
	  END DO! OF I      
*
*  Realization of the specified ensemble
          CALL SCALING(3)       ! mdstep.f     
	if(IPRINT.ge.7.and.LSEP)write(*,'(i5,3f12.7)')
     +NSTEB,SCLX,SCLY,SCLZ
	if(IPRINT.ge.8)write(*,'(a,I3,f12.3)')' sh.st.',NSTEB,TEMP
*
      END DO! OF NSTEB 
*
*- - - - - - - SLOW MOTION - - - - - - - -
*     
        DO I           = NAB(TASKID),NAE(TASKID)
	    ITYP	= ITYPE(I)
	    if(LMOVE(ITYP))then 
            VX(I)          =  VX(I)+TSTEP*GX(I)*0.5D0
            VY(I)          =  VY(I)+TSTEP*GY(I)*0.5D0
            VZ(I)          =  VZ(I)+TSTEP*GZ(I)*0.5D0
	    end if
        END DO! OF I
   	  if(LNPT)then
	    if(LSEP)then                 
	      TRLL(1)=(VIRX+VIRD/3.)*UNITP/VOL
	      TRLL(2)=(VIRY+VIRD/3.)*UNITP/VOL
	      TRLL(3)=(VIRZ+VIRD/3.)*UNITP/VOL
	      call BCAST(TRLL,3,MAST)
	if(IPRINT.ge.7)write(*,'(a,3f12.3)')' TRLL= ',TRLL   
	      if(LHEX)then
		TRLXY=0.5*(TRLL(1)+TRLL(2))
	        SCLX=SCLX+0.5d0*(TRLXY-TRPRES)*VOL*DQP*TSTEP
              SCLY=SCLX
	      else
	      SCLX=SCLX+0.5d0*(TRLL(1)-TRPRES)*VOL*DQP*TSTEP
	      SCLY=SCLY+0.5d0*(TRLL(2)-TRPRES)*VOL*DQP*TSTEP
	      end if
	      SCLZ=SCLZ+0.5d0*(TRLL(3)-TRPRES)*VOL*DQP*TSTEP
	    else
	      TRL=(VIR+PEST+VIRD)*UNITP/(3.*VOL)
	      call BCAST(TRL,1,MAST)
	      SCL=SCL+0.5d0*(TRL-TRPRES)*VOL*DQP*TSTEP 
	    end if
	  end if 
      timeg	= timeg+cputime(timeg0)
	call SINHV(2)
      timeg0	= cputime(0.d0)
*
*  Collecting averages
      VIRLL=VIRL+VIRLS
	PELL=PEST+PELS
	WIRSUM=WIRS+WIRSS
      TRYCKE	= PELL*UNITP/(3.*VOL)
      TRYCKL	= VIRLL*UNITP/(3.*VOL)
      TRYCKB	= VIRB*UNITP/(3.*VOL)
      TRYCKT	= VIRT*UNITP/(3.*VOL)
      TRYCKN	= VIRN*UNITP/(3.*VOL)
      TRYCKF	= WIRF*UNITP/(3.*VOL)
	TRYCKA	= VIRA(1)*UNITP/(3.*VOL)
	TRYCKS	= WIRSUM*UNITP/(3.*VOL)
	TRYCKD	= VIRD*UNITP/(3.*VOL)
*      T1	= VIR*UNITP/(3.*VOL)
*	T2	= VIRS*UNITP/(3.*VOL)
*	write(*,'(a4,3f12.3)')' P= ',T1,T2,T1+T2
*     CALL GETROT       ! supl.f
	CALL GETCOM         ! supl.f
	if(TASKID.eq.MAST)then
        CALL GETKIN       ! supl.f
        if(LCF)CALL DIPOLE       ! supl.f
        if(NHIST+1.ge.IHIST)CALL GETTCF       ! supl.f
        if(mod(MSTEP,IAVER).eq.0)CALL GETAVR(1)
	  if(mod(MSTEP,NTREK).eq.0)CALL TRACE
	end if
      PENL=PE*0.001*ENERF/FNOP
      PEL=PELL*0.001*ENERF/FNOP
      PENS=PINT*0.001*ENERF/FNOP
      PEKI=TKE*0.001*ENERF
      ETOT=PENL+PENS+PEKI
      POTEN	= PENL+PENS 
	PHD=POTLJ(MOLINT)*1.d-3*ENERF/NHDM
	DENS	= TOTMAS*1.d-3/(VOL*UNITL**3)
*
               WHICH = NONE
      IF(DONE) WHICH = SOME
	if(TASKID.eq.MAST)then
*      if(IPRINT.ge.6)WRITE(6,'(4(a6,f12.5))')
*     +' Eex= ',PENL,' Ein= ',PENS,' Eki= ',PEKI,' Etot=',ETOT 
        if(IPRINT.ge.5.and.mod(MSTEP,IAVER).eq.0)
     +  WRITE(6,991) MSTEP,POTEN,PENS,PEL,ETOT,TEMP,TRYCK,DENS
        if(IPRINT.ge.6)write(*,'(2f7.4,2f9.2,4f7.1,I7,I9)')
     +  SC,SCL,TRYCKM,PHD,TTR,TROT,TINT,TEMPV,MBSH,MBLN   
	  if(IPRINT.ge.6.and.LSEP)write(*,'(4f11.1,3f11.3)')
     + TRYCKX,TRYCKY,TRYCKZ,(TRYCKX+TRYCKY+TRYCKZ)/3.,BOXL,BOYL,BOZL
 	  if(IPRINT.ge.7.and.mod(MSTEP,IAVER).eq.0)
     +  WRITE(6,'(8f10.3)')TRYCKL,TRYCKE,TRYCKB,TRYCKA,TRYCKN,
     +  TRYCKF,TRYCKS,TRYCKD
  991 FORMAT(I7,4(1X,F9.3),2(1X,f9.2),f9.4)
*
        if(mod(MSTEP,NAVER).eq.0)CALL GETAVR(2)
*** Put you own subroutine for evaluation of whatever you want here:
***     call USER
***
	end if
CM   !Important - all nodes
      if(LDMP.and.mod(MSTEP,NDUMP).eq.0)call RESTRT(2)
      timeg	= timeg+cputime(timeg0)
*
*<---------------------
      if(NSTEP.lt.NSTEPS)go to 1
*<---------------------
*
      RETURN
      END
*
*=============== SCALING ==============================================
*
      SUBROUTINE SCALING(IAL)
*
*  NVT, NPT or NVE with temp-scaling ensembles
*    IAL=1      leap frog algorithm 
*        2      double time scale, before moves 
*        3                         after
      include "prcm.h"   
	parameter (FP3=0.5/3.)
	real*8 TRS(3)
*
	data DKEO/0./,ISKK/0/
	save  
*                      
      call GETEMP(.true.) 
* Pressure calculation  (true only for MAST node)
	VIRSUM	= VIR+VIRS+PEST+PELS+VIRD
*      WIRSUM	= VIRL+VIRLS+PEST+PELS+VIRD+WIRF+WIRS+WIRSS
      WIRSUM	= VIRL+VIRLS+PEST+PELS+VIRD+WIRS+WIRSS
	TRID	= 2.*TKE*UNITP/(3.*VOL)
	TRIDM	= (NOP-1)*BOLTZ*TEMP*1.d-5/(VOL*UNITL**3)
      TRYCK	= VIRSUM*UNITP/(3.*VOL)+TRID
	TRYCKM	= WIRSUM*UNITP/(3.*VOL)+TRIDM 
	TRYCKX	= (VIRX+VIRFX+VIRD/3.+VIRA(1))*UNITP/VOL+TRID
	TRYCKY	= (VIRY+VIRFY+VIRD/3.+VIRA(2))*UNITP/VOL+TRID
	TRYCKZ	= (VIRZ+VIRFZ+VIRD/3.+VIRA(3))*UNITP/VOL+TRID
*	write(*,'(5f13.2)')
*     +TRYCK,TRYCKX,TRYCKY,TRYCKZ,(TRYCKX+TRYCKY+TRYCKZ)/3.
	if(IAL.ge.2.and.LNPT)then 
	  if(LSEP)then
	    TRS(1)=VIRFX*UNITP/VOL+TRID       
	    TRS(2)=VIRFY*UNITP/VOL+TRID      
	    TRS(3)=VIRFZ*UNITP/VOL+TRID      
	  else 
	    TRS(1)=(VIRS+PELS)*UNITP/(3.*VOL)+TRID      ! fast virial 
	    TRS(2)=TRS(1)
	    TRS(3)=TRS(1)
	  end if
	  call BCAST(TRS,3,MAST)
	end if                
	if(IPRINT.ge.7.and.LSEP)write(*,'(3f12.3)')TRS
*
*    NPT molecular dynamics
*    
*   new thermostat parameters
	if(LNVT)then
	  DKE         = TEMP/TRTEMP-1.d0
*
*    1 step leap-frog algorithm
*
	  if(IAL.eq.1)then  
	    if(LNPT)then
	      if(LSEP)stop ' N P T not supported for rigid models'  
	      call BCAST(TRYCKM,1,MAST)         
	      DPE = TRYCKM-TRPRES
	      SCLO= SCL                                      ! ita (t-1/2)
	      SCL = (SCL+DPE*VOL*DQP*TSTEP)/(1.d0-SCL*TSTEP) ! ita (t+1/2)
	      SCLM= 0.5d0*(SCLO+SCL)                         ! ita (t)
	      N   = 0
            N0  = 0
            I         = 0
	      SCC	= 0.5d0*SCL*TSTEP
	      DCC	= SCC/(1.d0-SCC)
	      SCCV	= 0.5d0*SCLM*TSTEP
	      DCP	= SCCV/(1.d0-SCCV)
	      IMB = NNUM(NAB(TASKID))
	      IME = NNUM(NAE(TASKID))
	      do IMOL = IMB,IME
		ITYP = ITM(IMOL)
              SUMM        = SUMMAS (ITYP)
	        if(LMOVE(ITYP))then 
		  NSBEG = ISADR(ITYP)+1
		  NSEND = ISADR(ITYP+1)
		  XC       = 0.D0
      	  YC       = 0.D0
      	  ZC       = 0.D0
	          PXC	= 0.
                PYC	= 0.
                PZC	= 0.
Calculate C.O.M. vectors:                  
		  IBEG = ISADDR(ITYP)+1+NSITS(ITYP)*(IMOL-IADDR(ITYP)-1)
		  IEND = ISADDR(ITYP)+NSITS(ITYP)*(IMOL-IADDR(ITYP))
      	  DO N       = IBEG,IEND
      	    IS	= NSITE(N)
      	    XC       = XC+MASS(IS)*SX(N)
      	    YC       = YC+MASS(IS)*SY(N)
      	    ZC       = ZC+MASS(IS)*SZ(N)
                  PXC	= PXC+VX(N)
                  PYC	= PYC+VY(N)
                  PZC	= PZC+VZ(N)
                END DO! OF N
                XC       = XC/SUMM    ! COM after intergation velocities
      	  YC       = YC/SUMM
      	  ZC       = ZC/SUMM
*    NPT-scaling  - shift of COM and transl. momenta
		  DX       = (XC+X(IMOL))*DCC
                DY       = (YC+Y(IMOL))*DCC
                DZ       = (ZC+Z(IMOL))*DCC
                DVX	= (PXC+PX(IMOL))*DCP
                DVY	= (PYC+PY(IMOL))*DCP
                DVZ	= (PZC+PZ(IMOL))*DCP
      	  DO N       = IBEG,IEND
      	    IS	= NSITE(N)
                  SX (N)       = SX(N)+DX
                  SY (N)       = SY(N)+DY
                  SZ (N)       = SZ(N)+DZ
                  FAC	= MASS(IS)/SUMM
                  VX(N)	= VX(N)-DVX*FAC
                  VY(N)	= VY(N)-DVY*FAC
                  VZ(N)	= VZ(N)-DVZ*FAC
                end do
	        end if
            end do ! of ITYP 
            SCX = (1.d0+0.5d0*SCL*TSTEP)/(1.d0-0.5d0*SCL*TSTEP)
            call RECLEN(SCX,SCX,SCX)
	    end if   ! if(LNPT...
*   NVT-constraints dynamics
	    SCC = 0.5d0*SC*TSTEP 
	    do I=NAB(TASKID),NAE(TASKID)  
	      ITYP=ITYPE(I)
	      if(LMOVE(ITYP))then      
*  HX here are old velocities
	        VX(I)=(VX(I)-HX(I)*SCC)/(1.d0+SCC)   ! v(t+1/2)
	        VY(I)=(VY(I)-HY(I)*SCC)/(1.d0+SCC)
	        VZ(I)=(VZ(I)-HZ(I)*SCC)/(1.d0+SCC)
	      end if
	    end do  
          TEMP        = TEMP*(1.-2.*SCC)**2 
           if(LNPT)then
  	      SC = SC+(0.5d0*SCL**2-DQT/FNST)*TSTEP
	      SCL= (SCL-SCLO*SCC)/(1.d0+SCC)
	    end if
	    SC=SC+(TEMP/TRTEMP-1.d0)*DQT*TSTEP                   !  zeta(t+1)
*
*    multiple time step; t -> t+1/2
*    parallel version    
*
	  else if(IAL.eq.2)then  
	    SCC = 0.5d0*SC*TSTEB
          if(LNPT)then
*    pressure controll in each direction                 
	      if(LSEP)then        
		SCC3=SCC/3.
		SCLX=SCLX*(1.-SCC3)
		SCLY=SCLY*(1.-SCC3)
		SCLZ=SCLZ*(1.-SCC3)
	        SCL=SCLX+SCLY+SCLZ
	        SCC = SCC+0.5*SCL*TSTEB   
		if(LHEX)then
		  TRSXY=0.25*(TRS(1)+TRS(2)) 
	          SCLX=(SCLX+TRSXY*VOL*DQP*TSTEB)/(1.-0.5*SCLX*TSTEB) !ita(t+1/2)
		  SCLY=SCLX
		else      
	        SCLX=(SCLX+0.5*TRS(1)*VOL*DQP*TSTEB)/(1.-0.5*SCLX*TSTEB) !ita(t+1/2)
	        SCLY=(SCLY+0.5*TRS(2)*VOL*DQP*TSTEB)/(1.-0.5*SCLY*TSTEB) !ita(t+1/2)
		end if
	        SCLZ=(SCLZ+0.5*TRS(3)*VOL*DQP*TSTEB)/(1.-0.5*SCLZ*TSTEB) !ita(t+1/2)
	        SCL=SCLX+SCLY+SCLZ
	        DCLX = 0.5*SCLX*TSTEB
	        DCLY = 0.5*SCLY*TSTEB
	        DCLZ = 0.5*SCLZ*TSTEB
	        if(abs(DCLX).ge.0.1)then
	          write(*,*)' too strong fluctuations in NPT algorithm'
		  write(*,*)' Axes X: scaling factor ',DCLX
		  ISKK=ISKK+1   
	        else if(abs(DCLY).ge.0.1)then
	          write(*,*)' too strong fluctuations in NPT algorithm'
		  write(*,*)' Axes Y: scaling factor ',DCLY
		  ISKK=ISKK+1   
	        else if(abs(DCLZ).ge.0.1)then
	          write(*,*)' too strong fluctuations in NPT algorithm'
		  write(*,*)' Axes Z: scaling factor ',DCLZ
		  ISKK=ISKK+1                   
	        end if
		if(ISKK.gt.100)then 
	write(*,*)' !!! repeated failure of NPT-algorithm' 
	write(*,*)' !!! restart program with constant volume'
	write(*,*)' !!! or increase thermostat parameter for pressure'
                stop
		end if 
	        do I=NAB(TASKID),NAE(TASKID)
	          ITYP=ITYPE(I)
	          if(LMOVE(ITYP))then
	            SX(I)=(SX(I)+OX(I)*DCLX)/(1.d0-DCLX)    !  t+1
	            SY(I)=(SY(I)+OY(I)*DCLY)/(1.d0-DCLY)
	            SZ(I)=(SZ(I)+OZ(I)*DCLZ)/(1.d0-DCLZ)
	          end if
	        end do        
	        SCX = (1.d0+0.5d0*SCLX*TSTEB)/(1.d0-0.5d0*SCLX*TSTEB)
	        SCY = (1.d0+0.5d0*SCLY*TSTEB)/(1.d0-0.5d0*SCLY*TSTEB)
	        SCZ = (1.d0+0.5d0*SCLZ*TSTEB)/(1.d0-0.5d0*SCLZ*TSTEB)
              call RECLEN(SCX,SCY,SCZ)  
*  constant scalar pressure
	      else
	        SCL = SCL*(1.-SCC)
	        SCC = SCC+0.5*SCL*TSTEB          
*  There are several NPT algorithms differing in second order terms
*	      SCL = (SCL+0.5d0*TRS*VOL*DQP*TSTEB)                         !ita(t+1/2)
	        SCL=(SCL+0.5*TRS(1)*VOL*DQP*TSTEB)/(1.-0.5*SCL*TSTEB) !ita(t+1/2)
*  Limit
	        DCL = 0.5*SCL*TSTEB
	        if(abs(DCL).ge.0.1)then
	          write(*,*)' too strong fluctuations in NPT algorithm'
		  write(*,*)' scaling factor ',DCL
		  if(IPRINT.ge.7)then
		    write(*,*)'------------------->'
		    write(*,*)SCL,TRYCK,TRYCKM,TRS(1)*UNITP/(3.*VOL)
		    write(*,*)VIR*UNITP/(3.*VOL),VIRS*UNITP/(3.*VOL),
     + PESL*UNITP/(3.*VOL),PELS*UNITP/(3.*VOL), VIRD*UNITP/(3.*VOL)
		    write(*,*)'<-------------------'
		  end if
		  ISKK=ISKK+1
		  if(ISKK.gt.100)then 
	write(*,*)' !!! repeated failure of NPT-algorithm' 
	write(*,*)' !!! restart program with constant volume'
	write(*,*)' !!! or increase thermostat parameter for pressure'
                  stop
		  end if 
	        end if
	        do I=NAB(TASKID),NAE(TASKID)
	          ITYP=ITYPE(I)
	          if(LMOVE(ITYP))then
	            SX(I)=(SX(I)+OX(I)*DCL)/(1.d0-DCL)    !  t+1
	            SY(I)=(SY(I)+OY(I)*DCL)/(1.d0-DCL)
	            SZ(I)=(SZ(I)+OZ(I)*DCL)/(1.d0-DCL)
	          end if
	        end do        
	        SCX = (1.d0+0.5d0*SCL*TSTEB)/(1.d0-0.5d0*SCL*TSTEB)
              call RECLEN(SCX,SCX,SCX)
	      end if  ! of LSEP
          end if    ! of LNPT 
	    if(IPRINT.ge.8)write(*,'(a,3f10.6,5f12.1)')
     +' 1:',SC,SCC,SCL,TRYCK,TRYCKM,TRS
	    do I=NAB(TASKID),NAE(TASKID)
	      ITYP=ITYPE(I)
	      if(LMOVE(ITYP))then
	      VX(I) = VX(I) - SCC*FX(I)           ! t+1/2
	      VY(I) = VY(I) - SCC*FY(I)
	      VZ(I) = VZ(I) - SCC*FZ(I)
	      end if
	    end do                                      
	    TEMP = TEMP*(1.d0-SCC)**2
   	    DKEO         = TEMP/TRTEMP-1.d0            ! t+1/2
*
*   multiple time step; t+1/2 -> t+1
*
        else if(IAL.eq.3)then 
	    if(LNPT)then  
	      SC  = SC+(0.5d0*SCL**2-DQT/FNST)*TSTEB     
	      if(LSEP)then
		if(LHEX)then
		  TRSXY=0.25*(TRS(1)+TRS(2)) 
	          SCLX=(SCLX+TRSXY*VOL*DQP*TSTEB)/(1.-0.5*SCLX*TSTEB) !ita(t+1/2)
		  SCLY=SCLX
		else      
	        SCLX=(SCLX+0.5*TRS(1)*VOL*DQP*TSTEB)/(1.-0.5*SCLX*TSTEB) !ita(t+1)
	        SCLY=(SCLY+0.5*TRS(2)*VOL*DQP*TSTEB)/(1.-0.5*SCLY*TSTEB) !ita(t+1)
      	end if
	        SCLZ=(SCLZ+0.5*TRS(3)*VOL*DQP*TSTEB)/(1.-0.5*SCLZ*TSTEB) !ita(t+1)
	        SCL=SCLX+SCLY+SCLZ
	        SCC = 0.5d0*SCL*TSTEB  
	        SCLX = SCLX/(1.d0+FP3*SC*TSTEB)
	        SCLY = SCLY/(1.d0+FP3*SC*TSTEB)
	        SCLZ = SCLZ/(1.d0+FP3*SC*TSTEB)
	      else
*	      SCL = (SCL+0.5d0*TRS*VOL*DQP*TSTEB)                        !ita(t+1)
	        SCL = (SCL+0.5*TRS(1)*VOL*DQP*TSTEB)/(1.-0.5*SCL*TSTEB) !ita(t+1)
	        SCC = 0.5d0*SCL*TSTEB
	        SCL = SCL/(1.d0+0.5d0*SC*TSTEB)
	      end if
	    else
	      SCC = 0.d0
	    end if
	    SC  = SC+DKEO*DQT*TSTEB                   !  zeta(t+1)
	    SCC = SCC+0.5d0*SC*TSTEB
	    DCC = 1.d0/(1.d0+SCC)  
	    do I=NAB(TASKID),NAE(TASKID)
	      ITYP=ITYPE(I)
	      if(LMOVE(ITYP))then
	      VX(I) = VX(I)*DCC
	      VY(I) = VY(I)*DCC
	      VZ(I) = VZ(I)*DCC 
	      end if
	    end do
	    if(IPRINT.ge.8)write(*,'(a,3f10.6,5f12.1)')
     +' 2:',SC,SCC,SCL,TRYCK,TRYCKM,TRS
	  end if
      END IF!(LNVT...
*
* scale velocities if necessary
*
      IF(LSCLT) THEN                
        DO ITYP     = 1,NTYPES
          IF(DABS(TRTEMP-TEMPR(ITYP)).GT.TDELT.and.LMOVE(ITYP))THEN
            SCV         = DSQRT(TRTEMP/TEMPR(ITYP))
	      IBEG=ISADDR(ITYP)+1
	      IEND=ISADDR(ITYP+1) 
	      if(IBEG.le.NAB(TASKID))IBEG=NAB(TASKID)
	      if(IEND.gt.NAE(TASKID))IEND=NAE(TASKID)
	      do I=IBEG,IEND
              VX(I)       = SCV*VX(I)
              VY(I)       = SCV*VY(I)
              VZ(I)       = SCV*VZ(I) 
	      end do  
            if(IPRINT.ge.5)write(*,*)
     +      'velocities scaled by ',SCV,' for type',ITYP
            NRTSC(ITYP) =  NRTSC(ITYP)+1
	    end if
	  end do
        call GETEMP(.true.)
      END IF!(LSC...
      TKE	= TKE/FNOP
*
      RETURN
      END    
*
*=============== GETEMP ==============================================
*
      SUBROUTINE GETEMP(LPAR)
*
      include "prcm.h"       
	logical LPAR
*
      TKE         = 0.D0
      TEMP        = 0.D0 
	if(LPAR)then
        VSQ         = 0.D0
	  do ITYP=1,NTYPES
	    EKIN(ITYP)=0.
	  end do
        DO I     = NAB(TASKID),NAE(TASKID)
	    ITYP=ITYPE(I)
	    if(LMOVE(ITYP))then
            IF(LSHEJK) THEN
              XV          = (HX(I)+VX(I))*0.5D0
              YV          = (HY(I)+VY(I))*0.5D0
              ZV          = (HZ(I)+VZ(I))*0.5D0
              VSC         = (XV**2+YV**2+ZV**2)*MASSDI(I)
*
            ELSE
*
              VSC         = (VX(I)**2+VY(I)**2+VZ(I)**2)*MASSDI(I)
            END IF
	      VSQ=VSQ+VSC
*
            EKIN(ITYP)  = EKIN(ITYP)+0.5D0*VSC
	    end if ! if(LMOVE...                       
	  end do
        TEMP         = 0.5D0*VSQ       ! here: kinetic energy
	  do ITYP=1,NTYPES
          FNSPNS      = DFLOAT(NSITS(ITYP)*NSPEC(ITYP))
          EKIN(ITYP)  = EKIN(ITYP)*ENERF*TEMPF*TFACT(ITYP)/FNSPNS 
	  end do  
*   Total kin. energy sent to all nodes
	  call ALLSUM(TEMP,TKE,1)  
*   Temperatures of each type sent only to MAST
	  call SUMMA(EKIN,TEMPR,NTYPES,MAST)      
	  if(IPRINT.ge.8)then
	    do ITYP=1,NTYPES
	      write(*,*)ITYP,TEMPR(ITYP)
	    end do
	  end if
	else
      DO ITYP     = 1,NTYPES
        I           = ISADDR(ITYP)
        NSS         = NSITS (ITYP)
        NSP         = NSPEC (ITYP)
        NSPNS       = NSP*NSS
        FNSPNS      = DFLOAT(NSPNS)
        VSQ         = 0.D0
*       
	  if(LMOVE(ITYP))then
        IF(LSHEJK) THEN
          DO N        = 1,NSPNS
            I           = I+1
            XV          = (HX(I)+VX(I))*0.5D0
            YV          = (HY(I)+VY(I))*0.5D0
            ZV          = (HZ(I)+VZ(I))*0.5D0
            VSQ         = VSQ+(XV**2+YV**2+ZV**2)*MASSDI(I)
          END DO! OF I
*
        ELSE
*
          DO N        = 1,NSPNS
            I           = I+1
            VSQ         = VSQ+(VX(I)**2+VY(I)**2+VZ(I)**2)*MASSDI(I)
          END DO! OF I
        END IF
*
        TKE         = TKE+ 0.5D0*VSQ  
        EKIN(ITYP)  =      0.5D0*VSQ
        TEMPR (ITYP)  = EKIN(ITYP)*ENERF*TEMPF*TFACT(ITYP)/FNSPNS 
	  end if
      END DO! OF ITYP   
	end if
      TEMP        = 3.*TKE*ENERF*TEMPF/FNST
	if(TASKID.eq.MAST.and.IPRINT.le.5.and.MSTEP.gt.5000.and.
     +(TEMP.gt.2*TRTEMP.or.TEMP.le.0.5*TRTEMP))then 
	  call TESTCONF
	  if(TASKID.eq.MAST)then
	  write(*,*)' abnormal temperature: ',TEMP 
	  write(*,*)'system configuration:'
	  do I=1,NSTOT
	    write(*,'(I5,1x,2a4,a6,6f12.7)')I,NM(NSITE(I)),' on ',
     +    NAME(ITYPE(I)),SX(I),SY(I),SZ(I),VX(I),VY(I),VZ(I)
	  end do
	  write(*,*)' PROGRAM STOP. It may continue if IPRINT>5 '  
	  end if       
	  stop
	end if
      RETURN
      END
*
*====================== PULLBACK ====================================
* 
	subroutine PULLBACK
	include "prcm.h"                 
	ELINK=0.          
	do ITYP=1,NTYPES
	  if(IINIT(ITYP).eq.1)then
	    IBEG=ISADDR(ITYP)+1
	    IEND=ISADDR(ITYP+1) 
	    if(IBEG.lt.NAB(TASKID))IBEG=NAB(TASKID)
	    if(IEND.gt.NAE(TASKID))IEND=NAE(TASKID)
	    do I=IBEG,IEND
	      IS=NSITE(I)
	      DX=SX(I)-R(IS,1)
	      DY=SY(I)-R(IS,2)
	      DZ=SZ(I)-R(IS,3)
	      call PBC(DX,DY,DZ)
	      RR2=DX**2+DY**2+DZ**2
	      ELINK=ELINK+RR2
	      GX(I)=GX(I)-RLR*DX
	      GY(I)=GY(I)-RLR*DY
	      GZ(I)=GZ(I)-RLR*DZ
	    end do
	  end if
	end do
	ELNK=ELINK*0.001*AVSNO*BOLTZ*TRTEMP/FNOP  
	call SUMMA(ELNK,ELINK,1,MAST)
	if(IPRINT.ge.6)write(*,*)
     +'Deviation from correct structure ',ELINK
	return
	end
